"""
Created for obtaining data Anderson noise with particular rate

@author: Faluke Aikebaier
"""

### 1. Libraries
import matplotlib.pyplot as plt
import numpy as np
import tensorflow as tf
from tensorflow import keras
from tensorflow.keras import layers
from sklearn.model_selection import train_test_split
from sklearn.utils import shuffle

### 2. Loading and organizing data
loaded_data_X0= np.load("my_data_X.npy")
loaded_data_Y = np.load("my_data_Y.npy")

#### Inducing random noise
rand_matrix=np.random.random(loaded_data_X0.shape)-np.random.random(loaded_data_X0.shape) 
noise_rate=0.01 # Change this value to have different noise rate
loaded_data_X=loaded_data_X0+noise_rate*rand_matrix

trainX, testX, trainY, testY=train_test_split(loaded_data_X, loaded_data_Y, test_size=0.2, random_state=42)

### 3. Normalization
normalizer = layers.Normalization(input_shape=[64,], axis=None)
normalizer.adapt(trainX)

### 4. Model
model = tf.keras.Sequential([
    normalizer,
    layers.Dense(1024, activation='relu'),
    layers.Dense(2*1024, activation='relu'),
    layers.Dense(1024, activation='relu'),
    layers.Dense(units=1)])

model.compile(
    optimizer=tf.optimizers.Adam(learning_rate=0.00005),
    loss='mean_absolute_error')

history = model.fit(
    trainX,
    trainY,
    epochs=500,
    # Suppress logging.
    verbose=0,
    # Calculate validation results on 20% of the training data.#,batch_size=64
    validation_split = 0.2 )

### 5. Predicting and saving data
y = model.predict(testX)
np.save("noise_0.01.npy", testY-y)