"""
Created for obtaining heat plot for Anderson noise

@author: Faluke Aikebaier
"""

### 1. Libraries
import numpy as np
import matplotlib.pyplot as plt
import math as m
from scipy.interpolate import griddata

### 2. Data
data = np.load("anderson_noise.npy")

### 3. Full width at half maximum
fwhm_list=[]
zz=0
for kk in range(500,data.shape[1]+1,500):
    spline = UnivariateSpline(data[1,zz:kk], data[2,zz:kk]-np.max(data[2,zz:kk])/2)
    r1, r2 = spline.roots() # find the roots
    zz=kk
    
    fwhm_list.append(r2-r1)
newy=UnivariateSpline(data[0,list(range(0,data.shape[1],500))],fwhm_list)(data[0,list(range(0,data.shape[1],500))])
    
### 4. Gridding
xi = np.linspace(0,0.05,1000)
yi = np.linspace(-0.03,0.03,1000)

zi = griddata(points=(data[0,:], data[1,:]), values=data[2,:], xi=(xi[None,:], yi[:,None]), method='nearest')

### 5. Plotting
plt.plot(data[0,list(range(0,data.shape[1],500))],newy/2,'w',linewidth=3, linestyle=':')
plt.plot(data[0,list(range(0,data.shape[1],500))],-newy/2,'w',linewidth=3, linestyle=':')
plt.imshow(zi, cmap='inferno', vmin = 0, vmax = np.max(ndata2), \
           extent =[xi.min(), xi.max(), yi.min(), yi.max()],origin='lower',aspect='auto')
plt.xlabel(r'$\omega$',fontsize=22);
plt.ylabel(r'$(S_{\rm{corr}}^{\rm{test}}-S_{\rm{corr}}^{\rm{pred}})/N$',fontsize=22);
plt.xticks([0,0.02,0.04],fontsize=22);
plt.yticks([-0.02,0,0.02],fontsize=22);
cbar = plt.colorbar()
cbar.ax.tick_params(labelsize=22)
plt.rcParams['axes.axisbelow'] = True
plt.savefig('Anderson_noise.pdf',bbox_inches='tight')





