"""
Created for obtaining line plot for Anderson noise

@author: Faluke Aikebaier
"""

### 1. Libraries
import matplotlib.pyplot as plt
import numpy as np
import seaborn as sns
import pandas as pd

### 2. Data
noise_0000=np.load("noise_0.00.npy")
noise_0010=np.load("noise_0.01.npy")
noise_0020=np.load("noise_0.02.npy")
noise_0050=np.load("noise_0.05.npy")

### 3. Reorganizing the data
s_noise_0000 = pd.Series(np.ravel(noise_0000))
s_noise_0010 = pd.Series(np.ravel(noise_0010))
s_noise_0020 = pd.Series(np.ravel(noise_0020))
s_noise_0050 = pd.Series(np.ravel(noise_0050))

### 4. Plotting
ax=s_noise_0000.plot.kde(bw_method=0.4,linewidth=3,label=r'$\omega=0$')
s_noise_0010.plot.kde(bw_method=0.4,linewidth=3,label=r'$\omega=0.01$')
s_noise_0020.plot.kde(bw_method=0.4,linewidth=3,label=r'$\omega=0.02$')
s_noise_0050.plot.kde(bw_method=0.4,linewidth=3,label=r'$\omega=0.05$')
ax.set_xlim(-0.03, 0.03)
ax.set_xlabel(r'$(S_{\rm{corr}}^{\rm{test}}-S_{\rm{corr}}^{\rm{pred}})/N$',fontsize=22)
ax.set_ylabel("Density",fontsize=22)
plt.xticks(np.array([-0.02, 0, 0.02]), fontsize=22)
plt.yticks(fontsize=22)
ax.legend(fontsize=18,loc='upper right',bbox_to_anchor=(1.05, 1.0))
plt.savefig('kde_anderson_particular.pdf',bbox_inches='tight')





