"""
Created for generating figures of accuracy of the model

@author: Faluke Aikebaier
"""

### 1. Libraries
import matplotlib.pyplot as plt
import numpy as np
import pandas as pd

### 2. Loading data and model
testY_cc=np.load("testY_cc.npy")
trueY_cc=np.load("trueY_cc.npy")

testY_nn=np.load("testY_nn.npy")
trueY_nn=np.load("trueY_nn.npy")

testY_cn=np.load("testY_cn.npy")
trueY_cn=np.load("trueY_cn.npy")

### 3. Scatter plots
# Uncomment related lines to generate different scatter plots
plt.scatter(testY_cc, trueY_cc, marker=".",linewidth=3.0) # for model trained on two-point correlators
#plt.scatter(testY_nn, trueY_nn, marker=".",linewidth=3.0) # for model trained on four-point correlators
#plt.scatter(testY_cn, trueY_cn, marker=".",linewidth=3.0) # for model trained on both types of correlators
plt.plot(np.linspace(0,max(trueY_cc)),np.linspace(0,max(trueY_cc)),linewidth=3.0,color='red')
plt.xticks([0,0.2,0.4,0.6],fontsize=22);
plt.yticks([0,0.2,0.4,0.6],fontsize=22);
plt.xlabel(r'$S_{{\rm{corr}}}^{{\rm{test}}}/N$',fontsize=22);
plt.ylabel(r'$S_{{\rm{corr}}}^{{\rm{pred}}}/N$',fontsize=22);
plt.savefig('scatter_cc.pdf',bbox_inches='tight') # for model trained on two-point correlators
#plt.savefig('scatter_nn.pdf',bbox_inches='tight') # for model trained on four-point correlators
#plt.savefig('scatter_cn.pdf',bbox_inches='tight') # for model trained on both types of correlators