"""
Created for generating density plot for comparison

@author: Faluke Aikebaier
"""

### 1. Libraries
import matplotlib.pyplot as plt
import numpy as np
import pandas as pd

### 2. Loading data
testY_cc=np.load("testY_cc.npy")
trueY_cc=np.load("trueY_cc.npy")

testY_nn=np.load("testY_nn.npy")
trueY_nn=np.load("trueY_nn.npy")

testY_cn=np.load("testY_cn.npy")
trueY_cn=np.load("trueY_cn.npy")

s_kde_cc = pd.Series(np.ravel(testY_cc-trueY_cc))
s_kde_nn = pd.Series(np.ravel(testY_nn-trueY_nn))
s_kde_cn = pd.Series(np.ravel(testY_cn-trueY_cn))

### 3. Scatter plots
ax=s_kde_cc.plot.kde(bw_method=0.4,linewidth=3,label=r'${\rm{with\ }}C_{ij}^{ss^\prime}$')
s_kde_nn.plot.kde(bw_method=0.4,linewidth=3,label=r'${\rm{with\ }}f_{ij}^{ss^\prime}$')
s_kde_cn.plot.kde(bw_method=0.4,linewidth=3,label=r'$C_{ij}^{ss^\prime}{\rm{ and }}f_{ij}^{ss^\prime}$')
ax.set_xlim(-0.03, 0.03)
ax.set_xlabel(r'$(S_{\rm{corr}}^{\rm{test}}-S_{\rm{corr}}^{\rm{pred}})/N$',fontsize=22)
ax.set_ylabel("Density",fontsize=22)
plt.xticks(np.array([-0.02, 0, 0.02]), fontsize=22)
plt.yticks(fontsize=22)
ax.legend(fontsize=18,bbox_to_anchor=(0.57, 0.41))
plt.savefig('kde_comparing.pdf',bbox_inches='tight')
